<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: ALM_ItemAlmacen.xml */
/* Generado: 2020-08-18 04:21:24 */

/* Mantenimiento de los registros de la tabla ALM_ItemAlmacen */
abstract class BaseALM_ItemAlmacenDP extends ALM_ItemAlmacenBV
{
    /* Constructor ( Establece los valores desde un objeto ALM_ItemAlmacenBN ) */
    public function __construct( ALM_ItemAlmacenBN $o_ALM_ItemAlmacenBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_ALM_ItemAlmacenBN ) )
        {
            $this->setByBN( $o_ALM_ItemAlmacenBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto ALM_ItemAlmacenBN */
    public function setByBN( ALM_ItemAlmacenBN $o_ALM_ItemAlmacenBN )
    {
        if ( !is_null( $o_ALM_ItemAlmacenBN->getIdCompania() ) )
        {
            $this->setIdCompania( $o_ALM_ItemAlmacenBN->getIdCompania() );
        }
        if ( !is_null( $o_ALM_ItemAlmacenBN->getIdItem() ) )
        {
            $this->setIdItem( $o_ALM_ItemAlmacenBN->getIdItem() );
        }
        if ( !is_null( $o_ALM_ItemAlmacenBN->getIdAlmacen() ) )
        {
            $this->setIdAlmacen( $o_ALM_ItemAlmacenBN->getIdAlmacen() );
        }
        if ( !is_null( $o_ALM_ItemAlmacenBN->getIdCondicion() ) )
        {
            $this->setIdCondicion( $o_ALM_ItemAlmacenBN->getIdCondicion() );
        }
        if ( !is_null( $o_ALM_ItemAlmacenBN->getUbicacionFisica() ) )
        {
            $this->setUbicacionFisica( $o_ALM_ItemAlmacenBN->getUbicacionFisica() );
        }
        if ( !is_null( $o_ALM_ItemAlmacenBN->getUbicacionFisica02() ) )
        {
            $this->setUbicacionFisica02( $o_ALM_ItemAlmacenBN->getUbicacionFisica02() );
        }
        if ( !is_null( $o_ALM_ItemAlmacenBN->getUbicacionFisica03() ) )
        {
            $this->setUbicacionFisica03( $o_ALM_ItemAlmacenBN->getUbicacionFisica03() );
        }
        if ( !is_null( $o_ALM_ItemAlmacenBN->getStockPedido() ) )
        {
            $this->setStockPedido( $o_ALM_ItemAlmacenBN->getStockPedido() );
        }
        if ( !is_null( $o_ALM_ItemAlmacenBN->getStockMinimo() ) )
        {
            $this->setStockMinimo( $o_ALM_ItemAlmacenBN->getStockMinimo() );
        }
        if ( !is_null( $o_ALM_ItemAlmacenBN->getStockMaximo() ) )
        {
            $this->setStockMaximo( $o_ALM_ItemAlmacenBN->getStockMaximo() );
        }
        if ( !is_null( $o_ALM_ItemAlmacenBN->getStockPuntoReorden() ) )
        {
            $this->setStockPuntoReorden( $o_ALM_ItemAlmacenBN->getStockPuntoReorden() );
        }
        if ( !is_null( $o_ALM_ItemAlmacenBN->getTiempoEspera() ) )
        {
            $this->setTiempoEspera( $o_ALM_ItemAlmacenBN->getTiempoEspera() );
        }
        if ( !is_null( $o_ALM_ItemAlmacenBN->getValidacionPedidoComercialFlag() ) )
        {
            $this->setValidacionPedidoComercialFlag( $o_ALM_ItemAlmacenBN->getValidacionPedidoComercialFlag() );
        }
        if ( !is_null( $o_ALM_ItemAlmacenBN->getEstado() ) )
        {
            $this->setEstado( $o_ALM_ItemAlmacenBN->getEstado() );
        }
        if ( !is_null( $o_ALM_ItemAlmacenBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_ALM_ItemAlmacenBN->getUsuarioModificacion() );
        }
        if ( !is_null( $o_ALM_ItemAlmacenBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_ALM_ItemAlmacenBN->getFechaModificacion() );
        }
        if ( !is_null( $o_ALM_ItemAlmacenBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_ALM_ItemAlmacenBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_ALM_ItemAlmacenBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_ALM_ItemAlmacenBN->getFechaCreacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_ALM_ItemAlmacenFN = new ALM_ItemAlmacenFN();
        $o_ALM_ItemAlmacenBN = $o_ALM_ItemAlmacenFN->selectByPk( $this->getIdCompania(), $this->getIdItem(), $this->getIdAlmacen(), $this->getIdCondicion() );
        if ( is_null( $o_ALM_ItemAlmacenBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO ALM_ItemAlmacen ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCompania";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItem() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdItem";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdItem()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdAlmacen() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdAlmacen";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdAlmacen()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCondicion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCondicion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdCondicion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUbicacionFisica() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UbicacionFisica";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUbicacionFisica()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUbicacionFisica02() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UbicacionFisica02";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUbicacionFisica02()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUbicacionFisica03() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UbicacionFisica03";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUbicacionFisica03()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getStockPedido() ) )
            {
                $s_SQLQuery1 .= $s_Separator."StockPedido";
                $s_SQLQuery2 .= $s_Separator."".$this->getStockPedido()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getStockMinimo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."StockMinimo";
                $s_SQLQuery2 .= $s_Separator."".$this->getStockMinimo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getStockMaximo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."StockMaximo";
                $s_SQLQuery2 .= $s_Separator."".$this->getStockMaximo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getStockPuntoReorden() ) )
            {
                $s_SQLQuery1 .= $s_Separator."StockPuntoReorden";
                $s_SQLQuery2 .= $s_Separator."".$this->getStockPuntoReorden()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTiempoEspera() ) )
            {
                $s_SQLQuery1 .= $s_Separator."TiempoEspera";
                $s_SQLQuery2 .= $s_Separator."".$this->getTiempoEspera()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getValidacionPedidoComercialFlag() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ValidacionPedidoComercialFlag";
                $s_SQLQuery2 .= $s_Separator."'".$this->getValidacionPedidoComercialFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Estado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE ALM_ItemAlmacen SET ";
            $s_Separator = "";
            if ( !is_null( $this->getUbicacionFisica() ) )
            {
                $s_SQLQuery .= $s_Separator."UbicacionFisica = '".$this->getUbicacionFisica()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUbicacionFisica02() ) )
            {
                $s_SQLQuery .= $s_Separator."UbicacionFisica02 = '".$this->getUbicacionFisica02()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUbicacionFisica03() ) )
            {
                $s_SQLQuery .= $s_Separator."UbicacionFisica03 = '".$this->getUbicacionFisica03()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getStockPedido() ) )
            {
                $s_SQLQuery .= $s_Separator."StockPedido = ".$this->getStockPedido()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getStockMinimo() ) )
            {
                $s_SQLQuery .= $s_Separator."StockMinimo = ".$this->getStockMinimo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getStockMaximo() ) )
            {
                $s_SQLQuery .= $s_Separator."StockMaximo = ".$this->getStockMaximo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getStockPuntoReorden() ) )
            {
                $s_SQLQuery .= $s_Separator."StockPuntoReorden = ".$this->getStockPuntoReorden()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTiempoEspera() ) )
            {
                $s_SQLQuery .= $s_Separator."TiempoEspera = ".$this->getTiempoEspera()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getValidacionPedidoComercialFlag() ) )
            {
                $s_SQLQuery .= $s_Separator."ValidacionPedidoComercialFlag = '".$this->getValidacionPedidoComercialFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery .= $s_Separator."Estado = '".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdCompania = ".$this->getIdCompania()." AND  IdItem = '".$this->getIdItem()."' AND  IdAlmacen = '".$this->getIdAlmacen()."' AND  IdCondicion = '".$this->getIdCondicion()."';";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM ALM_ItemAlmacen WHERE  IdCompania = ".$this->getIdCompania()." AND  IdItem = '".$this->getIdItem()."' AND  IdAlmacen = '".$this->getIdAlmacen()."' AND  IdCondicion = '".$this->getIdCondicion()."';";
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        return true;
    }

}
?>